
#include <iostream>
#include <vector>
#include "histogram.h"
using namespace std;

void find_minmax(const vector<double> &numbers, double &min, double &max)
{
    max = numbers[0];
    min = numbers[1];
    for (double x: numbers)
    {
        if (x < min)
        {
            min = x;
        }
        else if (x > max)
        {
            max = x;
        }
    }
    return;

}

vector<size_t> make_histogram (vector<double> numbers, size_t bin_count)
{

    double minn;
    double maxx;
    find_minmax (numbers, minn, maxx);
    double bin_size = (maxx - minn) / bin_count;
    vector<size_t> bins(bin_count);
    for (size_t i = 0; i < numbers.size(); i++)
    {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++)
        {
            auto lo = minn + j * bin_size;
            auto hi = minn + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi))
            {
                bins[j]++;
                found = true;
            }
        }
        if (!found)
        {
            bins[bin_count - 1]++;
        }
    }
    return bins;
}


